import { Course } from '@app/core/models/course';
import { TermCode } from '@app/core/models/termcode';

export type PlannedTermEra = 'past' | 'active' | 'future';

export type PlannedTermNote =
  | { isLoaded: true; text: string; id: number }
  | { isLoaded: false; text: string };

export interface PlannedTerm {
  termCode: TermCode;
  era: PlannedTermEra;
  note?: PlannedTermNote;
  plannedCourses: Course[];
  enrolledCourses: Course[];
}
