import { Pipe, PipeTransform } from '@angular/core';
import * as utils from '@app/degree-planner/shared/utils';
import { YearCode, TermCode } from '@app/core/models/termcode';

@Pipe({
  name: 'academicYearState',
})
export class AcademicYearStatePipe implements PipeTransform {
  transform(yearCode: string | YearCode, activeTermCodes: TermCode[]): string {
    if (typeof yearCode === 'string') {
      yearCode = new YearCode(yearCode);
    }

    const era = utils.pickYearEra(yearCode, activeTermCodes);
    switch (era) {
      case 'past':
        return `Past: ${yearCode.fromYear}-${yearCode.toYear}`;
      case 'future':
        return `Future: ${yearCode.fromYear}-${yearCode.toYear}`;
      default:
        return `Current: ${yearCode.fromYear}-${yearCode.toYear}`;
    }
  }
}
